﻿using System.Collections.Generic;
using System.Web.Mvc;
using System.Web.Routing;
using Orchard.Core.Containers;
using Orchard.Mvc.Routes;

namespace Orchard.CulturePicker {
    public class Routes : IRouteProvider {
        private readonly IContainersPathConstraint _containersPathConstraint;

        public Routes(IContainersPathConstraint containersPathConstraint) {
            _containersPathConstraint = containersPathConstraint;
        }

        public void GetRoutes(ICollection<RouteDescriptor> routes) {
            foreach (var routeDescriptor in GetRoutes())
                routes.Add(routeDescriptor);
        }

        public IEnumerable<RouteDescriptor> GetRoutes() {
            return new[] {
                //TODO (ermakovich): still not sure why we need it, but without this route Orchard can`t find controller action properly
                new RouteDescriptor {
                    Route = new Route(
                        "ChangeCulture",
                        new RouteValueDictionary {
                            {"area", "Orchard.CulturePicker"},
                            {"controller", "UserCulture"},
                            {"action", "ChangeCulture"}
                        },
                        new RouteValueDictionary(),
                        new RouteValueDictionary {
                            {"area", "Orchard.CulturePicker"}
                        },
                        new MvcRouteHandler())
                },
                new RouteDescriptor {
                    Priority = 21,
                    Route = new Route(
                        "",
                        new RouteValueDictionary {
                            {"area", "Orchard.CulturePicker"},
                            {"controller", "LocalizableHome"},
                            {"action", "Index"}
                        },
                        new RouteValueDictionary {
                            {"area", "Orchard.CulturePicker"},
                            {"controller", "LocalizableHome"},
                        },
                        new RouteValueDictionary {
                            {"area", "Orchard.CulturePicker"}
                        },
                        new MvcRouteHandler())
                },
                new RouteDescriptor {
                    Priority = 16,
                    Route = new Route(
                        "{*path}",
                        new RouteValueDictionary {
                            {"area", "Orchard.CulturePicker"},
                            {"controller", "LocalizableItem"},
                            {"action", "Display"}
                        },
                        new RouteValueDictionary {
                            {"path", _containersPathConstraint}
                        },
                        new RouteValueDictionary {
                            {"area", "Orchard.CulturePicker"}
                        },
                        new MvcRouteHandler())
                }
        };
        }
    }
}